#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "dump4xi.py">
#<abstract4xi abstract = "provides function dump4xi"/>
#<refer4xi name = "forking.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'dump4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from forkingpickler4xi import ForkingPickler4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "dump4xi" usage = "
#   dumping objects
#"> 
#<note4xi note = "dump function of popen4xi.py offers the same services"/>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def dump4xi(obj, file, protocol=None): 
    '''
    dumping objects
    '''
    # ---------------------------------------------------------------------------------------------
    # WARNING: do NOT use this but instead use dump function embedded inside popen4xi.py !!!
    # ---------------------------------------------------------------------------------------------    
    # class2xi = "dump4xi"
    # method2xi = "dump4xi"

    # message2print = "{started" + "; dump4xi-started: " + str(dump4xi)  + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)  
    
    # message2print = "{passed" + "; object-passed-to-dump4xi: " + str(obj) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)  
    
    # message2print = "{passed" + "; file-passed-to-dump4xi: " + str(file) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)  
    
    # message2print = "{passed" + "; protocol-passed-to-dump4xi: " + str(protocol) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)  

       
    # ---------------------------------------------------------------------------------------------
    # WARNING: do NOT use this but instead use dump function embedded inside popen4xi.py !!!
    # ---------------------------------------------------------------------------------------------   
    # message2print = "{passing" + "; file-passing-to-ForkingPickler4Xi-by-dump4xi: " + str(file) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)          
        
    # message2print = "{passing" + "; protocol-passing-to-ForkingPickler4Xi-by-dump4xi: " + str(protocol) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)           

    # message2print = "{passing" + "; object-passing-to-dump-of-ForkingPickler4Xi-by-dump4xi: " + str(obj) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)          
        
                     
    
    ForkingPickler4Xi(file, protocol).dump(obj)
    
        
    # message2print = "{performed" + "; dump-of-ForkingPickler4Xi-performed-by-dump4xi: " + str(ForkingPickler4Xi.dump) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)             
           
    
    # -------------------------------------------------------------------------------------------
    # WARNING: do NOT use this but instead use dump function embedded inside popen4xi.py !!!
    # --------------------------------------------------------------------------------------------- 
    # message2print = "{returning" + "; dump4xi-returning: " + time4xi() + "}" 
    # print4xi(class2print, method2print, message2print)      
    
    return
            
#</function4xi> 

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dump4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

